;=======================================================
; 145   / 10154  AT89C2051
;..  <alldn@mail.ru> ,  2003.
;  
;    .
;  5 .
;=======================================================
; 
;
dseg    at      30h
;
sst0:   ds      1       ;
sst1:   ds      1       ; 
sst2:   ds      1       ; 10154
sst3:   ds      1       ;
;
tim_dh: ds      1       ;
tim_dm: ds      1       ; 
tim_dl: ds      1       ;Save Mode

scan_h: ds      1
scan_m: ds      1
scan_l: ds      1
;
kbuf:   ds      1       ; 
;
;=======================================================
;,    
;
rx0:    ds      1       ; 
rx1:    ds      1       ;
;
tx0:    ds      1       ; 
tx1:    ds      1       ;
;
intf0:  ds      1       ; 
intf1:  ds      1       ;
;
osc0:   ds      1       ;  
osc1:   ds      1       ;
;
;=======================================================
;  
stack:  ds      1       ; 
;
;=======================================================
; 

cseg    at      0
        using   0
cold_start:
        ajmp     main
;
;=======================================================
;
;=======================================================
;,  
;
init:
        mov     intf0,#08h
        mov     intf1,#05bh
        mov     osc0,#008h
        mov     osc1,#000h

        mov     r5,#50h
        acall   delay           ;
wait_init:
        mov     a,p3
        anl     a,#07h
        cjne    a,#07h,set_channels
                                ;  
        ajmp    wait_init       ;  
;
set_channels:
        mov     kbuf,p3         ;
        anl     kbuf,#07h       ; 
;
        mov     r5,#50h
        acall   delay           ;

        jnb     p3.0,chan1      ;1 ?
        jnb     p3.1,chan2      ;2 ?
        jnb     p3.2,chan3      ;3 ?
        jmp     chan1           ;   .
chan1:                          ;                        *
        mov     rx0,#071h       ;  1   *
        mov     rx1,#084h       ; 145300                 *
        mov     tx0,#071h       ;  1 *
        mov     tx1,#084h       ; 145300                 *
        ret                     ;                        *
chan2:                          ;                        *
        mov     rx0,#071h       ;  2   *
        mov     rx1,#0ach       ; 145500                 *
        mov     tx0,#071h       ;  2 *
        mov     tx1,#0ach       ; 145500                 *
        ret                     ;                        *
chan3:                          ;                        *
        mov     rx0,#071h       ;  3   *
        mov     rx1,#0cfh       ; 145675                 *
        mov     tx0,#071h       ;  3 *
        mov     tx1,#057h       ; 145075                 *
        ret                     ;                        *
;-------------------------------------------------------
; 
;-------------------------------------------------------
delay:
        mov     r4,#0
delay1:
        djnz    r4,$
        djnz    r5,delay
        ret
;
;-------------------------------------------------------
;    1015PL4
;-------------------------------------------------------
prep_syn:
        mov     sst0,osc0
        mov     sst1,osc1
        jnb     p1.4,tx_mod     ;?

        mov     sst2,rx0        ;, 
        mov     sst3,rx1
        sjmp    prep0
tx_mod:
        mov     sst2,tx0        ;, 
        mov     sst3,tx1
prep0:
;
        jnb     p1.4,txm2       ;?
        clr     c               ;, 
        mov     a,sst3          ; 
        subb    a,intf1         ;
        mov     sst3,a
        mov     a,sst2
        subb    a,intf0
        mov     sst2,a
txm2:
        mov     a,sst3
        anl     a,#7h
        rl      a
        inc     a
        mov     r6,a
        anl     sst3,#0f8h
;
        mov     r3,#3
txm1:                           ;   
        clr     c
        mov     a,sst3
        rlc     a
        mov     sst3,a
        mov     a,sst2
        rlc     a
        mov     sst2,a
        mov     a,sst1
        rlc     a
        mov     sst1,a
        mov     a,sst0
        rlc     a
        mov     sst0,a
        djnz    r3,txm1
;
        mov     a,r6
        orl     sst3,a
                                ;  4  
        mov     r0,#sst0
prep1:
        mov     a,@r0
        acall   outsst
        inc     r0
        cjne    r0,#sst3+1,prep1

        nop
        nop                     ;    4
        setb    p1.2            ;CLK=1 _-
        nop
        nop
        clr     p1.2            ;CLK=0 -_

        ret
;-------------------------------------------------------
;   4.   
;-------------------------------------------------------
outsst:
        mov     r4,#8h          ; 8   .
        clr     c               ; cary
outs1:
        rlc     a               ; A   C
        mov     p1.0,c          ; DATA=C
        nop
        setb    p1.3            ;CLK=1 _-
        nop
        clr     p1.3            ;CLK=0 -_
        djnz    r4,outs1        ;  .
;
        ret
;-------------------------------------------------------
;  
;-------------------------------------------------------
transmit:
        acall   clrdel          ;  Save Mode
        mov     r5,#10h
        acall   delay           ;
        acall   prep_syn        ;   
trans1:
        jnb     p1.4,trans1     ;  
        mov     r5,#10h
        acall   delay           ;
        ajmp    main_loop

;-------------------------------------------------------
;  Save Mode
;-------------------------------------------------------
clrdel:
        mov     tim_dh,#0
        mov     tim_dm,#0
        mov     tim_dl,#0
        clr     p1.1            ;SM=0 -_   
        ret
;
;-------------------------------------------------------
;  Save Mode   
;-------------------------------------------------------
inc_wait:
        mov     a,tim_dl
        add     a,#1
        mov     tim_dl,a
        mov     a,tim_dm
        addc    a,#0
        mov     tim_dm,a
        mov     a,tim_dh
        addc    a,#0
        mov     tim_dh,a
        cjne    a,#02h,no_wait
wait_on:
        setb    p1.1            ;SM=1 _-
;      ~0.3 .
        mov     tim_dh,#1
        mov     tim_dm,#0e6h
        mov     tim_dl,#0
;      ~0.9 .
        mov     r5,#0
        acall   delay           ;Save Mode
        mov     r5,#0
        acall   delay           ;Save Mode
        mov     r5,#0
        acall   delay           ;Save Mode
        mov     r5,#0
        acall   delay           ;Save Mode
        mov     r5,#0
        acall   delay           ;Save Mode
        mov     r5,#0
        acall   delay           ;Save Mode
no_wait:
        clr     p1.1            ;SM=0 -_
        ret
;*******************************************************
;
MAIN:
        clr     ea
        mov     sp,#stack
        mov     p1,#0ffh
        mov     p3,#0ffh
        mov     r5,#10h
        acall   delay
        jnb     p1.4,scan       ; 
;
main_loop:
;
        acall   clrdel          ;  SM
        acall   init            ; 
        acall   prep_syn        ;     4
;
loop1:
        clr     p1.1            ;SM=0 -_   
loop2:
        mov     a,p3
        anl     a,#007h
;
        cjne    a,kbuf,sinkey   ; 
        jnb     p1.4,transmit   ; 
        jnb     p1.7,sm_off     ;  - SM=OFF
;
        acall   inc_wait
;
        ajmp    loop1
sm_off:
        acall   clrdel
        ajmp    loop1
sinkey:
;
        sjmp    main_loop
;-------------------------------------------------------
; 
;-------------------------------------------------------
scan:
        mov     a,p3
        anl     a,#07
        mov     kbuf,a
        acall   init            ; 
        jnb     p1.4,$          ;  
loop_sc:
        mov     rx0,#070h       ;  
        mov     rx1,#0e4h       ; 144500
        mov     tx0,#070h
        mov     tx1,#0e4h
loop_sc1:
        acall   prep_syn        ;     4
        mov     tim_dh,#0
        mov     tim_dm,#0
        mov     tim_dl,#0
loop_s1:
        jnb     p1.4,scan_t     ; 
        mov     a,tim_dl
        add     a,#1
        mov     tim_dl,a
        mov     a,tim_dm
        addc    a,#0
        mov     tim_dm,a

        cjne    a,#016h,loop_s1

        mov     tim_dh,#0
        mov     tim_dm,#0
        mov     tim_dl,#0
        setb    c
loop_s2:
        jnc     scan_st         ;   
        clr     p1.1            ;SM=0 -_   
        jnb     p1.4,scan_t     ; 
        jnb     p1.7,scan_wt    ;  - SM=OFF

        mov     a,p3            ; 
        anl     a,#07
        cjne    a,kbuf,exit

        mov     a,tim_dl
        add     a,#1
        mov     tim_dl,a
        mov     a,tim_dm
        addc    a,#0
        mov     tim_dm,a

        cjne    a,#16h,loop_s2
        ajmp    scan_st
scan_wt:
        mov     a,tim_dl
        add     a,#1
        mov     tim_dl,a
        mov     a,tim_dm
        addc    a,#0
        mov     tim_dm,a
        mov     a,tim_dh
        addc    a,#0
        mov     tim_dh,a
        cjne    a,#03h,loop_s2
scan_st:                        ;   
        setb    p1.1            ;SM=1 _-  
        mov     a,rx1
        add     a,#5
        mov     rx1,a
        mov     tx1,a
        mov     a,rx0
        addc    a,#0
        mov     rx0,a
        mov     tx0,a

        cjne    a,#071h,loop_sc1
        mov     a,rx1
        cjne    a,#0edh,loop_sc1

        ajmp    loop_sc
;-------------------------------------------------------
;    
;-------------------------------------------------------
scan_t:
        acall   clrdel          ;  SM
        mov     r5,#10h
        acall   delay           ;

        acall   prep_syn        ;     4

        jnb     p1.4,$          ;  
        mov     r5,#10h
        acall   delay           ;

        acall   prep_syn        ;     4
scan_t1:
        clr     p1.1            ;SM=0 -_   

        mov     a,p3            ; 
        anl     a,#07
        cjne    a,kbuf,exit

        jnb     p1.7,scan_nosm  ;  - SM=OFF
        acall   inc_wait
        jb      p1.4,scan_t1    ;  
        ajmp    scan_t
scan_nosm:
        acall   clrdel
        ajmp    scan_t1
exit:
        ajmp    main
;
;*******************************************************
;
        END

